\name{Graph to Matrix coersions}
\alias{coerce,graphNEL,matrix-method}

\title{Coercing matrices to graphs}
\description{
Functions for converting graph objects into matrices
}
\details{
A \code{graphNEL} can be directly coerced into a \code{adjacency} matrix
using the \code{as} method. If the graph is \code{undirected} then the
matrix will by symmetric.

}
\value{
  An adjacency 
  For \code{aM2bpG}, an object of class \code{graphNEL}.  For
  \code{ftM2adjM}, an adjacency matrix representation of the coerced graph.
}

\author{Byron Ellis}

\examples{

From <- matrix(sample(c(0,1),16,replace=TRUE),ncol=4,nrow=4)
dimnames(From) <- list(LETTERS[1:4],LETTERS[1:4])
To <- as(From,"graphNEL")
Back <- as(To,"matrix")
if(sum(From == Back) != 16) warning("conversion failed")

}

\keyword{graphs }
