\name{startids}
\alias{startids}
\alias{newID}
\alias{nullgraphID}
\alias{idenv}
\title{Functions to associate identifiers with graph components.}
\description{
  We are experimenting with different methods for dealing with
  components of graphs (such as subgraphs). One way to do this is to
  assign a unique identifier to each component of a graph. Subgraphs
  then need only retain the identity of the graph and the ids for the
  selected components.

  The intention is to have these be internal to the graph package and
  they will likely not be exported. They are primarily for housekeeping
  purposes.

  There are currently two ways of assigning IDs. One relies on the
  \code{Ruuid} package the other on integers. In the long run only
  \code{Ruuid} will be supported.
}
\usage{
startids(x)
newID(cur)
}
\arguments{
  \item{x}{an integer to start numbering components from.}
  \item{cur}{an integer, the current index}

}
\details{
  \code{startids} sets the starting value for the sequence. It has
}
\value{
  These are used basically just for side effects and internally. Users
  should not use them. If you want uuids please use \code{Ruuid}
  directly. 
}

\author{R. Gentleman }
\examples{

}
\keyword{ manip }

